> For the complete documentation index, see [llms.txt](https://docs.vechainkit.vechain.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.vechainkit.vechain.org/hooks/blockchain-hooks.md).

# Blockchain Hooks

### `useCurrentBlock()`

Fetches the current block from the blockchain with automatic updates.

```typescript
const { data, isLoading, error } = useCurrentBlock();
```

Features:

* Auto-refreshes every 10 seconds
* Caches data for 1 minute
* Returns the latest expanded block information

Example:

```typescript
function BlockInfo() {
  const { data: block } = useCurrentBlock();
  
  return <div>Current Block: {block?.number}</div>;
}
```

### `useTxReceipt()`

Polls the blockchain for a transaction receipt until it is found or times out.

```typescript
const { data, isLoading, error } = useTxReceipt(txId, blockTimeout);
```

Parameters:

* txId: (string) The transaction ID to monitor
* blockTimeout: (optional number) Number of blocks to wait before timing out (default: 5)

Returns:

* data: Transaction receipt (TransactionReceipt)
* isLoading: Boolean indicating if the receipt is being fetched
* error: Error object if the operation fails

Example:

```typescript
function TransactionStatus({ txId }) {
  const { data: receipt, isLoading } = useTxReceipt(txId);
  
  if (isLoading) return <div>Loading...</div>;
  return <div>Transaction Status: {receipt?.reverted ? 'Failed' : 'Success'}</div>;
}
```

## Utility Functions

### **`useEvents()`**

Fetches events from the blockchain based on specified criteria.

```typescript
const events = await getEvents({
   abi,
   contractAddress,
   eventName,
   filterParams,
   mapResponse,
   nodeUrl,
});
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.vechainkit.vechain.org/hooks/blockchain-hooks.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
